##
##  whetstone.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         whetstone
Summary:      The Whetstone CPU Double-Precision Floating-Point Arithmetic Benchmark
URL:          http://www.whetstone.org/
Vendor:       Brian Wichmann & Rich Painter
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Benchmark
License:      Open Source
Version:      1.2
Release:      20080101

#   list of sources
Source0:      http://www.netlib.org/benchmark/whetstone.c
Patch0:       whetstone.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101

%description
    Whetstone was the first major synthetic benchmark program, intended
    to be representative for numerical (floating-point intensive)
    programming. It is based on statistics gathered by Brian Wichmann
    at the National Physical Laboratory in England, using an Algol 60
    compiler which translated Algol into instructions for the imaginary
    Whetstone machine. The compilation system was named after the small
    town of Whetstone outside the City of Leicester, England, where it
    was designed. The bechmark gives a MIPS rating.

%track
    prog whetstone = {
        disabled
        comment   = "rse: no versioned distribution file, but not changing anymore anyway"
        version   = %{version}
        url       = http://www.netlib.org/benchmark/
        regex     = whetstonec.c
    }

%prep
    %setup -q -c -T
    cp %{SOURCE0} .
    %patch -p0

%build
    %{l_cc} %{l_cflags -O} -o whetstone whetstone.c -lm

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin
    ( echo "#!/bin/sh"
      echo "iterations=\${1-80000}"
      echo "%{l_prefix}/bin/whetstone-bm \$iterations | tee whetstone.out"
    ) >whetstone.sh
    %{l_shtool} install -c -m 755 \
        whetstone.sh $RPM_BUILD_ROOT%{l_prefix}/bin/whetstone
    %{l_shtool} install -c -s -m 755 \
        whetstone $RPM_BUILD_ROOT%{l_prefix}/bin/whetstone-bm
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

